<template>
  <q-page padding>
    <q-toolbar>
      <q-btn to="/" icon="arrow_back" color="secondary" unelevated flat round />
      <q-separator vertical class="q-mx-sm" inset />
      <q-toolbar-title class="text-secondary">
        SW Planets List
      </q-toolbar-title>
      <q-btn
        label="add planet"
        @click="addPlanetDialog = true"
        icon="add"
        color="secondary"
        unelevated
      />
    </q-toolbar>
    <PlanetsList
      :planets="planets"
      :count="planetsCount"
      :error="error"
      :loading="loading"
    />
    <q-dialog v-model="addPlanetDialog" persistent>
      <q-card style="width: 700px" class="rounded-borders">
        <q-toolbar class="bg-primary">
          <q-toolbar-title class="text-white">
            New planet
          </q-toolbar-title>
        </q-toolbar>
        <q-card-section>
          <PlanetCreateForm />
        </q-card-section>
      </q-card>
    </q-dialog>
  </q-page>
</template>

<style></style>

<script>
import { mapState } from 'vuex'
import PlanetsList from 'src/components/PlanetsList'
import PlanetCreateForm from 'src/components/forms/PlanetCreateForm'

export default {
  name: 'PlanetsPage',
  components: { PlanetsList, PlanetCreateForm },
  data: () => ({
    addPlanetDialog: false,
  }),
  computed: {
    ...mapState('planets', {
      planets: ({ planetsList: { data } }) => (data ? data.results : []),
      planetsCount: ({ planetsList: { data } }) => (data ? data.count : 0),
      loading: ({ planetsList: { loading } }) => loading,
      error: ({ planetsList: { error } }) => error,
    }),
  },
  mounted() {
    this.$store.dispatch('planets/getPlanetsList')
  },
}
</script>
